<?php

    # Directory listings of RHaworth.me

    # ---------------------------------------

function cvarx($v)
{
    if (isset($_REQUEST['varx'])) varx($v);
}

    # ---------------------------------------

    require_once('../incl/photinc.php');
    require_once('../incl/rwhhead.php');

    $lk_self=cano_uri();

    $_g['hompa']=get_home_paths();
    cvarx($_g['hompa']);

    $_g['cnf']=parse_ini_file("{$_g['hompa']['coodir']}rh_ftp.cnf");
    cvarx($_g['cnf']);

    $host=(isset($_REQUEST['h']) ? $_REQUEST['h'] : "net");
    # I am so paranoid about ucoz applying another block that I will use net for testing
    $pwd=(isset($_g['cnf']["rh_{$host}_uspas"]) ? $_g['cnf']["rh_{$host}_uspas"] : $_REQUEST['pwd']);
    $_g['fhn']=ftp_connect($_g['cnf']["rh_{$host}_urn"]);
    $res=ftp_login($_g['fhn'],$_g['cnf']["rh_{$host}_usnam"],$pwd);
    cvarx($res);

    $res=ftp_chdir($_g['fhn'],"/{$_REQUEST['p']}");   cvarx($res);
    $curdir= ftp_pwd($_g['fhn']);   # normalise directory name. directory / is the http home page level
    cvarx($curdir);

    cvarx(ftp_systype($_g['fhn']));
    cvarx(ftp_pasv($_g['fhn'],true));
    cvarx(ftp_raw($_g['fhn'],'PWD'));
    cvarx($res=ftp_rawlist($_g['fhn'],"-a ."));   

  # cvarx(ftp_raw($_g['fhn'],'mkd foobar'));
  # cvarx(ftp_raw($_g['fhn'],'LIST -l .'));

    $titext="RHaworth.$host$curdir directory listing";
    rwhhead($titext,"http://rhaworth.$host$curdir","noindex,nofollow");
?>

<style type="text/css">

body { font-size: 100%; }

td  { margin: 0px; border: 0px red solid; }

.stats { font-family: monospace; font-size: 90%; padding: 0 0 2px; vertical-align: bottom; }

</style>

</head>
<body>

<div style='margin: 1em;'>

<?php

    echo "<h3 style='text-align: left;'>Directory of: RHaworth.$host$curdir</h3>\n&nbsp;<br/>";

    if (!strlen($pwd)) {
        echo "Usage is: &nbsp; <tt>?pwd=&hellip;&h=me&p=<i>directory</i></tt><br/>\n".
             "&nbsp;<br/>\n".
             "<a href='https://tools.wmflabs.org/os/test/showphp.php?php=dir4rhm.php' ".
             "target='_blank'>View source</a><br/>\n";
             # strictly speaking we should use $_SERVER['SCRIPT_NAME' or 'SCRIPT_FILENAME']
             # to get our name and the path to us
        exit();
    }

    if (strpos($_SERVER['SCRIPT_FILENAME'],'rhaworth.net')) {

?>
<div style="width: 30em;">

2013 Jan. I find that ucoz which hosts RHaworth.me is applying a very specific block:
it refuses to return any results for ftp_nlist or ftp_rawlist if the request is coming
from the IP address of RHaworth.net.
But it still allows an mkdir command from that address!
This block is presumably because rwhgal1.php (in oph_db.php) was 
issuing an nlist request every time it was entered.  

</div>
</div>
</body>
</html>
<?php   exit();

    }
    echo "<table cellpadding='0' cellspacing='0' >\n";

    foreach ($res as $row) {
        # echo $row ."\n";
        do { 
            $j=strlen($row);
            $row=str_replace('  ',' ',$row);
        } while ($j!=strlen($row));
        $rw=explode(' ',$row);

        $rw[0]= substr($row, 0,10);  $isdir=(substr($rw[0],0,1)=='d');
        $dirsz= sprintf('%4d%10d',$rw[1],$rw[4]);
        $datim= sprintf('%s%3s%6s',$rw[5],$rw[6],$rw[7]);
        $stats=str_replace(' ','&nbsp;',"<tt>$rw[0]$dirsz  $datim </tt>");
        if (!$isdir) $ubigx[$rw[8]]=1;
        $newpath=$curdir .(strlen($curdir)>1 ? '/' : ''). $rw[8];
        echo "<tr><td class='stats'>$stats</td><td>".
             ($isdir ? '&nbsp;dir &nbsp;' : '') ."</td>\n<td><a href='".
             ($isdir ? "$lk_self?p=$newpath&pwd=$pwd&h=$host'" 
                     : "$newpath' target='_blank'") .
             ">$rw[8]</a></td></tr>\n";
             # strictly speaking $lk_self should use https:
             # Links when !$isdir don't work om .net because of httpdocs
    }
    ftp_close($_g['fhn']);

    $s_ubigx=serialize($ubigx);
    echo "</table>\n</div>\n". "<!-- API $s_ubigx -->\n";
    flush();

    if (strlen($curdir)>1) {  # never any images in the home directory
        $_g['frhn']=ftp_connect($_g['cnf']['rh_net_urn']);
        $res=ftp_login($_g['frhn'],$_g['cnf']['rh_net_usnam'],$pwd);
        # assumes .net and .me use same password
        cvarx(ftp_pasv($_g['frhn'],true));

        $tmpf_hn=fopen("tmp.txt","w+");  fwrite($tmpf_hn,$s_ubigx);  fclose($tmpf_hn);
        ftp_put($_g['frhn'],($host=='me' ? "/httpdocs" : "") ."{$curdir}/remoim.txn",
                 "tmp.txt",FTP_ASCII);
      # $res=ftp_chdir($_g['frhn'],"/httpdocs$curdir");  # cvarx($res);
      # $res=ftp_rawlist($_g['frhn'],"-a .");  cvarx($res);
        ftp_close($_g['frhn']);
 
        echo "&nbsp;<br/>\n".
             "Output written to remoim.txn - needs hand move to *.txt<br/>\n";
    }

    echo "</body>\n</html>\n";

?>
