<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta name="Author" content="Roger W. Haworth" />
	<title>Grid Ref to map sources redirector</title>
	<meta name="description" content="Ordnance Survey GB front end for WikiProject Geographical coordinates" />
	<meta name="keywords" content="OScoor, OSGB36, national grid, Wikipedia, coor" />

<!--	<link rel="stylesheet" type="text/css" href="/ccc.css" />
	<script type="text/javascript" src="/ccc_java.js"></script>
-->
</head>
<body text="#000000" bgcolor="#FFFFCC" link="#0000EE" vlink="#551A8B" alink="#FF0000">

<h3>GB Grid Reference to Lat/Long converter</h3>

<?php
    echo 'Error: <span style="color: #700; font-size: 120%;">'. $errmess .'</span><br />
        &nbsp;<br />
        Search argument is: <b>?'. htmlspecialchars($_SERVER["QUERY_STRING"]) .'</b><br />';
?>

&nbsp;<br />

<a href='http://en.wikipedia.org/wiki/Template:OS_coord'>How to use this resource</a> |
<a href='http://toolserver.org/~rhaworth/os/showlog.php'>Usage log</a> |
<a href="javascript:history.go(-1)">Go back</a>

<br />&nbsp;<br />

<a href='http://en.wikipedia.org/wiki/British_national_grid_reference_system'>What
is a grid reference anyway?</a><br />
&nbsp;<br />
Code derived from <a href='http://www-users.cs.york.ac.uk/~fisher/software/coco/series/convert.c'>convert.c</a> found among <a href='http://www-users.cs.york.ac.uk/~fisher/software/coco/'>Tony Fisher's files</a>.<br />
See also this <i><a
href='http://www.ordnancesurvey.co.uk/oswebsite/gi/nationalgrid/nghelp1.html'>interactive guide to the National Grid</a></i>.
<br />&nbsp;
<br />&nbsp;

<div>
Copyright &copy; 2005 - 2011
<a href="http://rhaworth.me/rhaworth.htm">Roger W Haworth</a> and several others
<br />&nbsp;<br />
This program is free software; you can redistribute it and/or modify it
under the terms of the <a
href="http://www.fsf.org/licensing/licenses/gpl.txt">GNU General Public
Licence</a> as published by the Free Software Foundation; either version 2
of the License, or any later version.
<br />&nbsp;<br />
This program is distributed in the hope that it will be useful, but <b>without
any warranty</b>; without even the implied warranty of <b>merchantability</b> or
<b>fitness for a particular purpose</b>.  See the <a
href="http://www.fsf.org/licensing/licenses/gpl.txt">GNU General Public
Licence</a> for more details.
<br />&nbsp;<br />

<h4>Source code</h4>

<table>
<?php

    $modlist=array(
	array('','','compared with geohack.php and includes as at 2011 Feb 23'),
	array('cooerr.php','this file, included by coor_g.php on errors','new'),
	array('coor_g.php','OSGB36 &rarr; WGS84 converter<br/>Roger Haworth\'s own work. All the following are by others &nbsp;','new'),
	array('geohack.php','map sources display','can use geotemplate.txt for testing'),
	array('geo_param.php','included by geohack.php','same'),
	array('helm_gb.php','required by transversemercator.php','new'),
	array('llfuncsm.php','required by coor_g.php','new'),
	array('mapsources.php','included by geohack.php','uses WGS2OSGB() and generates $osgb36_6fig'),
	array('transversemercator.php','required by mapsources.php','added WGS2OSGB'),
    );
    foreach ($modlist as $mli) {
      echo "<tr><td><a href='http://toolserver.org/~rhaworth/showphp.php?php=os/{$mli[0]}'>{$mli[0]}</a> &nbsp;</td>".
           "<td>{$mli[1]}</td><td>{$mli[2]}</td></tr>\n";
    }

?>
</table>
</div>
</body>
</html>
