<?php

//  ----------------------------------------

function OSlet ( $ch )
{
    $j = strpos('abcdefghjklmnopqrstuvwxyzABCDEFGHJKLMNOPQRSTUVWXYZ',$ch);

    if ($j!==false) { $j %= 25; $res[1]= 4-(int)($j/5); $res[0]=$j%5; }
    return $res;
}

function rnum ( $ns )   // round up easting or northing to 5 digits
{
    return substr($ns.'50000',0,5);
}

function get_gr ()      // extract first term from $parm
{
    global $parm;

    $parm=str_replace('&nbsp;','',str_replace('&#160;','',str_replace(' ','',$parm)));
    $j=strpos($parm,'_');
    if ($j!==false) {
        $gr=substr($parm,0,$j); $parm=substr($parm,$j);
    } else {
        $gr=$parm; $parm='';
    }
    return $gr;
}

function getarg($sarg,$key) {    // emulate the parsing done to create $_REQUEST
    if (($j=strpos($sarg,$key))!==false) {
        $j+=(strlen($key)-1); $k=strpos($sarg,'&',$j);
        return ($k ? substr($sarg,$j,$k-$j) : substr($sarg,$j));
        // including the '=' sign in the return value appears to be the easiest way
        // to distinguish between 'key missing' and 'key present with zero length'
    } else
        return false;
}
/*      We need this function because we want to recover the referer exactly
        as it came to oscoor_a.htm. But we have had to pass it via $_REQUEST
        which does irreversible conversions. */

function p_from_r( $referer )   // if referer is normal Wikipedia, return the pagename
{
    global $ref_xlat;

    $ref_list= array(
        'http://en.wikipedia.org/wiki/',
        'http://en.wikipedia.org/w/index.php?title=',
        'http://en.m.wikipedia.org/wiki/',
    );
    $ref_x_list= array( 'p=>', 'p=>', 'm=>', );

    $referer= str_replace($ref_list,$ref_x_list,$referer);
    if (substr($referer,1,1)=='=') {
        $ref_xlat=substr($referer,0,3);  $pn=substr($referer,3);
      if ($j1=strpos($pn,'?')) $pn=substr($pn,0,$j1);
      if ($j1=strpos($pn,'&')) $pn=substr($pn,0,$j1);
        return urldecode($pn);
    } else {
        return $ref_xlat=false;
    }
}

//  Logging --------------------------------

function logit()
{
        global $testver, $refer_db, $ref_xlat, $mybyflag, $bwt_err, $rh_com;

        $lognam='callo'. ($testver ? 't' : 'g') .'.txt';

        $referer= $_SERVER['HTTP_REFERER'];
        if (!$mybyflag) {       // else called from myby and $refer_db has already been extracted
            $refer_db=$referer;
            if (strlen($referer)>0 && strlen($_REQUEST['pagename'])>0)
                // Wikipedia does not do a proper urlencode() but what it does is
                // compatible with urldecode()
                if (strcmp(urldecode($_REQUEST['pagename']), p_from_r($referer))!=0)
                        { $refer_db=$referer;  $refull=''; }
                else    { $refer_db=$ref_xlat; $refull=$referer; }
        }

/*  logging disabled

        if ($rh_com) {
            $dhn = mysql_connect('localhost','rhaworth_oscoo','osgb36') 
                   or die('Could not connect: ' . mysql_error());
            mysql_select_db('rhaworth_osco') or die('Could not select database');
        } else {
            require_once('../incl/mymysql.php');
            $dhn= mymy_connect('sql','u_rhaworth_osco_p');
        }
        $msq = "INSERT INTO `". substr($lognam,0,6) ."`
            (`datim`,`ipaddr`,`referer`,`refull`,`pagename`,`params`,`myby`,`browser`) VALUES
            (now(),'". $_SERVER['REMOTE_ADDR'] ."','".
            addslashes($refer_db) ."','". addslashes($refull) ."','". 
            addslashes($_REQUEST['pagename']) ."','".
            $_REQUEST['params'] ."',". ($mybyflag? 1 : 0) .",'".
            addslashes($_SERVER['HTTP_USER_AGENT']) ."')" ;
        $insres= ( mysql_query($msq) ? '' : ' ** INSERR **');
        # echo 'insres = '. $insres .'<br/>';

        mysql_close($dhn);

end logging disabled */

        $fhn = fopen($lognam,'ab');
        if (filesize($lognam)<5E5) {   // ftell() is undefined for files opened in append mode
            fwrite($fhn,date('y m d H:i') .' '.
                (strlen($referer)>0 ? $referer : '-') .' '.
                $_SERVER['QUERY_STRING'] .' "'.
                $_SERVER['HTTP_USER_AGENT'] .'" '. $insres .
                (strlen($bwt_err)>0 ? ' "'. $bwt_err .'"' : '') .chr(13).chr(10) );
        }
        fclose($fhn);
}

//      -------------------------------------

$baddies = array
(
    'areabot/1.0',
);

//  main() --------------------------------

    error_reporting(0x7FFF ^ (E_NOTICE | E_STRICT));    # ^ (E_WARNING | E_NOTICE));
    ini_set('display_startup_errors',1);
    ini_set("display_errors",1);

    require_once ('llfuncsm.php');

    $testver=(strpos($_SERVER['SCRIPT_NAME'],'coor_g')===false);
    $rh_com=($_SERVER['SERVER_NAME']=='rhaworth.com');

    if (($myby=getarg($_SERVER["QUERY_STRING"],'myby='))!==false) {
        # echo '>>'. $myby .'<< $myby='. ($myby? 'true':'false') .chr(10);
        $mybyflag=true;
        $refer_db= $_SERVER['HTTP_REFERER'];    // default
        if (strlen($myby)>8) {
            $myby=substr($myby,1);
            if (($pn=p_from_r($myby))!==false)
                { $refer_db='=>p'; $_REQUEST['pagename']=urlencode($pn); }
            else
                { $refer_db=$myby; }
            $_SERVER['HTTP_REFERER']= $myby;
        }
    }
    unset($_REQUEST['myby']);

    $parm=$_REQUEST['params'];  
    /*  We assume that this item will not have any magic quote-able characters.
        $_REQUEST['pagename'] and any other search arguments may well contain
                magic quote-ables but we leave them untouched because if we are
                going to include geohack.php, the state of $_REQUEST must be
                compatible with geohack being called directly */
    do {

    if (strlen($parm)<1) {
        $errmess='This page requires a search argument with a <i>params=</i> term
                (ie. &nbsp;?params=...&nbsp; after the URL)';
        break;
    }

        $gr=get_gr();   // extract first term from $parm
        if (preg_match('/(^[A-HJ-Za-hj-z]{1,2})([0-9]{0,10})/',$gr,$mats)!=0) {
            // Two letter "Landranger" format
            # echo "$gr - mats[] {$mats[1]} {$mats[2]}<br />\n";

            $lres=OSlet(substr($mats[1],0,1));
            $e=500000*($lres[0]-2); $n=500000*($lres[1]-1);
            # echo ' ll='. $j .' '. $lat .' '. $lon .'<br />\n';

            $lres=OSlet(substr($mats[1],1,1));
            $e += 100000*$lres[0]; $n += 100000*$lres[1];
            # echo ' ll='. $j .' '. $lat .' '. $lon .'<br />\n';

            $j=strlen($mats[2]);
    if (($j%2)!=0 || $j>10) {
        $errmess='If alpha used, there must be an even number of digits';
        break;
    }
            $j /= 2;
            $e += rnum(substr($mats[2],0,$j)); $n += rnum(substr($mats[2],$j,$j));

        } else {        // see if it is all-numeric format

            if ( ($j=strpos($gr,','))>0 ) {
                $e=substr($gr,0,$j); $n=substr($gr,$j+1);
            } else {
                $e=$gr; $parm=substr($parm,1); /* remove the first '_' */
                                     $n=get_gr();
            }
    if (preg_match('/^[0-9]*$/',$e)==0 || preg_match('/^[0-9]*$/',$n)==0) {
        $errmess='Invalid grid reference format';
        break;
    }

        }

        if (strlen($mats[1])!=1) {

    if ( $e<0 || $e>=700000 || $n<0 || $n>=1300000 ) {
        $errmess= 'easting='. $e .' and/or northing='. $n .' is outside the
                valid range for Great Britain (0,0 to 700000,1300000)';
        break;
    }
            // Now have valid OSGB east and northings. Let's convert ****

            $ll=NGR2LL($gr);    // Gives different values. Does not support all-numeric 
            # echo "<pre>". var_export($ll,true) ."</pre>";

            # echo 'en= '. $e .' '. $n .'<br />';
            $ll=GBgr_num2ll($e,$n);
 
       } else {

            $ll=NGR2LL($gr);  $ll[0]=$ll[2]; $ll[1]=$ll[3];

        }

        # echo "<pre>". var_export($ll,true) ."</pre>";

        if (isset($_REQUEST['bwt'])) { include('tm_bwt.php'); } # Compare with Streetmap

        $_SERVER['HTTP_USER_AGENT']=str_replace($baddies,'403 ',$_SERVER['HTTP_USER_AGENT']);

        logit();        // before we modify the search arguments

        if ((int)$_SERVER['HTTP_USER_AGENT']==403) {
            header("HTTP/1.0 403 Forbidden");
            echo '403 Forbidden';
            exit();
        }

        $parm= $ll[0] .'_N_'. $ll[1] .'_E'. $parm;
        if (stripos($parm,'region:')===false) $parm .= "_region:". (strlen($mats[1])!=1 ? "GB" : "IE");

        $_REQUEST['params'] = $parm;
        // Updating $_GET apparently does not change $_REQUEST.
        // Since geohack.php uses $_REQUEST and ignores $_GET, we do the same

        $new_qs='';
        foreach( $_REQUEST as $ky => $val ) {
            $new_qs .= (strlen($new_qs)==0 ? '' : '&'). $ky .'='.
                urlencode( (get_magic_quotes_gpc() ? stripslashes($val) : $val) );
        }
        # $_SERVER["QUERY_STRING"] = $new_qs;   // $_SERVER is not examined in either case

        $uri = 'geohack.php?'. $new_qs;
        if (!$testver) $uri = 'http://toolserver.org/~geohack/'. $uri;

        # echo '<br /><a href="'. htmlspecialchars($uri) .'" target="_new">'. $new_qs .'</a><br />';

        # if ($testver)
        if (!$rh_com) include('geohack.php'); else header('location: '. $uri );

        exit();

    } while (false);

    include('cooerr.php');

?>
